'=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~
'  Example program using the MaskEdit.inc file
'
'  by William Burns
'=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~
#COMPILE EXE
#REGISTER NONE
#DIM ALL
#INCLUDE "win32api.inc"
#INCLUDE "MaskEdit.inc"
%IDUNUSED           = 100
%TXTDATE            = 120
%TXTFIRST           = 125
%TXTLAST            = 130
%TXTPHONE           = 135
%TXTMASK            = 140
%TXTMASKTXT         = 145
%LABMSG             = 150
DECLARE CALLBACK FUNCTION DLGPROC
'=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~
FUNCTION PBMAIN
   LOCAL hDlg     AS LONG
   DIALOG NEW 0, "MaskEdit Test", 0, 0,  267,  220, %WS_POPUP OR %DS_MODALFRAME OR %WS_CAPTION OR %WS_MINIMIZEBOX OR %WS_SYSMENU OR %DS_CENTER, 0 TO hDlg
   CONTROL ADD FRAME, hDlg, %IDUNUSED, "Phone Number:", 5, 116, 251, 37, %WS_CHILD OR %WS_VISIBLE OR %BS_GROUPBOX, %WS_EX_TRANSPARENT
   CONTROL ADD FRAME, hDlg, %IDUNUSED, "Enter Last Name:", 5, 79, 251, 34, %WS_CHILD OR %WS_VISIBLE OR %BS_GROUPBOX, %WS_EX_TRANSPARENT
   CONTROL ADD FRAME, hDlg, %IDUNUSED, "Enter First Name:", 5, 42, 251, 34, %WS_CHILD OR %WS_VISIBLE OR %BS_GROUPBOX, %WS_EX_TRANSPARENT
   CONTROL ADD FRAME, hDlg, %IDUNUSED, "Enter Date:  mm/dd/yyyy", 5, 5, 251, 34, %WS_CHILD OR %WS_VISIBLE OR %BS_GROUPBOX, %WS_EX_TRANSPARENT
   CONTROL ADD FRAME, hDlg, %IDUNUSED, "Custom Mask:", 5, 160, 120, 34, %WS_CHILD OR %WS_VISIBLE OR %BS_GROUPBOX, %WS_EX_TRANSPARENT
   CONTROL ADD FRAME, hDlg, %IDUNUSED, "Custom Test Text:", 125, 160, 120, 34, %WS_CHILD OR %WS_VISIBLE OR %BS_GROUPBOX, %WS_EX_TRANSPARENT
   CONTROL ADD TEXTBOX, hDlg, %TXTDATE, "__/__/____", 13, 20, 232, 12, %WS_CHILD OR %WS_VISIBLE OR %ES_AUTOHSCROLL OR %WS_TABSTOP, %WS_EX_CLIENTEDGE
   CONTROL ADD TEXTBOX, hDlg, %TXTFIRST, "_________", 13, 54, 232, 12, %WS_CHILD OR %WS_VISIBLE OR %ES_AUTOHSCROLL OR %WS_TABSTOP, %WS_EX_CLIENTEDGE
   CONTROL ADD TEXTBOX, hDlg, %TXTLAST, "________", 13, 94, 232, 12, %WS_CHILD OR %WS_VISIBLE OR %ES_AUTOHSCROLL OR %WS_TABSTOP, %WS_EX_CLIENTEDGE
   CONTROL ADD TEXTBOX, hDlg, %TXTPHONE, "(___)___-____", 13, 130, 232, 12, %WS_CHILD OR %WS_VISIBLE OR %ES_AUTOHSCROLL OR %WS_TABSTOP, %WS_EX_CLIENTEDGE
   CONTROL ADD TEXTBOX, hDlg, %TXTMASK, "Time ##:## >LM", 13, 172, 100, 12, %WS_CHILD OR %WS_VISIBLE OR %ES_AUTOHSCROLL OR %WS_TABSTOP, %WS_EX_CLIENTEDGE
   CONTROL ADD TEXTBOX, hDlg, %TXTMASKTXT, "Time __:__ _M", 135, 172, 100, 12, %WS_CHILD OR %WS_VISIBLE OR %ES_AUTOHSCROLL OR %WS_TABSTOP, %WS_EX_CLIENTEDGE
   CONTROL ADD LABEL, hDlg, %LABMSG, "Ready?", 13, 200, 232, 12, %WS_CHILD OR %WS_VISIBLE OR %SS_CENTER, %WS_EX_CLIENTEDGE
   DIALOG SHOW MODAL hDlg, CALL DLGPROC
END FUNCTION
'=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~
CALLBACK FUNCTION DLGPROC
   LOCAL sText AS STRING
   LOCAL iRet  AS LONG
   IF CBCTLMSG=%EN_SETFOCUS THEN CONTROL SET TEXT CBHNDL, %LABMSG, ""
   SELECT CASE CBMSG
      CASE %WM_COMMAND
         SELECT CASE CBCTL
            CASE  %TXTDATE
               IF CBCTLMSG=%EN_CHANGE THEN iRet = MaskEdit(CBHNDL,%TXTDATE,"#9/#9/####")
            CASE  %TXTFIRST
               IF CBCTLMSG=%EN_CHANGE THEN iRet = MaskEdit(CBHNDL,%TXTFIRST,">L<L??????????????????")
            CASE  %TXTLAST
               IF CBCTLMSG=%EN_CHANGE THEN iRet = MaskEdit(CBHNDL,%TXTLAST,">L<L??????????????????")
            CASE  %TXTPHONE
               IF CBCTLMSG=%EN_UPDATE THEN iRet = MaskEdit(CBHNDL,%TXTPHONE,"(###)###-####")
               IF CBCTLMSG=%EN_SETFOCUS THEN CONTROL SEND CBHNDL, %TXTPHONE, %EM_SETSEL, 1, 1   'start on pos 1
            CASE  %TXTMASK
               IF CBCTLMSG=%EN_UPDATE THEN
                  CONTROL SET TEXT CBHNDL, %TXTMASKTXT, " "
               END IF
            CASE  %TXTMASKTXT
               IF CBCTLMSG=%EN_UPDATE THEN
                  CONTROL GET TEXT CBHNDL, %TXTMASK TO sText
                  iRet = MaskEdit(CBHNDL,%TXTMASKTXT,sText)
               END IF
            CASE ELSE
         END SELECT
         IF iRet = %TRUE THEN
            CONTROL SET TEXT CBHNDL, %LABMSG, "Good enough for that field"
         ELSEIF CBCTLMSG=%EN_UPDATE THEN
            CONTROL SET TEXT CBHNDL, %LABMSG, "This field needs more data"
         END IF
      CASE ELSE
   END SELECT
END FUNCTION
'=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~
